"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createVersionSpec = exports.getPref = exports.getPrefix = void 0;
const error_1 = __importDefault(require("@pnpm/error"));
exports.getPrefix = (alias, name) => alias !== name ? `npm:${name}@` : '';
function getPref(alias, name, version, opts) {
    const prefix = exports.getPrefix(alias, name);
    return `${prefix}${createVersionSpec(version, opts.pinnedVersion)}`;
}
exports.getPref = getPref;
function createVersionSpec(version, pinnedVersion) {
    switch (pinnedVersion !== null && pinnedVersion !== void 0 ? pinnedVersion : 'major') {
        case 'none':
            return '*';
        case 'major':
            return `^${version}`;
        case 'minor':
            return `~${version}`;
        case 'patch':
            return `${version}`;
        default:
            throw new error_1.default('BAD_PINNED_VERSION', `Cannot pin '${pinnedVersion !== null && pinnedVersion !== void 0 ? pinnedVersion : 'undefined'}'`);
    }
}
exports.createVersionSpec = createVersionSpec;
//# sourceMappingURL=getPref.js.map