"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getNonDevWantedDependencies(pkg) {
    var _a, _b;
    const bd = (_a = pkg.bundleDependencies) !== null && _a !== void 0 ? _a : pkg.bundleDependencies;
    const bundledDeps = new Set(Array.isArray(bd) ? bd : []);
    bundledDeps.add(pkg.name);
    const filterDeps = getNotBundledDeps.bind(null, bundledDeps);
    return getWantedDependenciesFromGivenSet(filterDeps({ ...pkg.optionalDependencies, ...pkg.dependencies }), {
        devDependencies: {},
        optionalDependencies: (_b = pkg.optionalDependencies) !== null && _b !== void 0 ? _b : {},
    });
}
exports.default = getNonDevWantedDependencies;
function getWantedDependenciesFromGivenSet(deps, opts) {
    if (!deps)
        return [];
    return Object.keys(deps).map((alias) => ({
        alias,
        dev: !!opts.devDependencies[alias],
        optional: !!opts.optionalDependencies[alias],
        pref: deps[alias],
    }));
}
function getNotBundledDeps(bundledDeps, deps) {
    return Object.keys(deps)
        .filter((depName) => !bundledDeps.has(depName))
        .reduce((notBundledDeps, depName) => {
        notBundledDeps[depName] = deps[depName];
        return notBundledDeps;
    }, {});
}
//# sourceMappingURL=getNonDevWantedDependencies.js.map